From 050777aa069d8a37646bc09ff9f05c28c68dfce2 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 728/1001] Convert the rules widget


---

diff --git a/hubs/widgets/rules/__init__.py b/hubs/widgets/rules/__init__.py
new file mode 100644
index 0000000..742ff22
--- /dev/null
+++ b/hubs/widgets/rules/__init__.py
@@ -0,0 +1,72 @@
+from __future__ import unicode_literals
+
+from collections import OrderedDict as ordereddict
+
+from hubs import validators
+from hubs.utils import username2avatar
+from hubs.widgets.chrome import panel
+from hubs.widgets.base import Widget, WidgetView
+
+
+ELLIPSIS_LIMIT = 5
+
+
+class Rules(Widget):
+
+    name = "rules"
+    position = "both"
+    arguments = [
+        dict(
+            name="link",
+            label="Link",
+            default=None,
+            validator=validators.link,
+            help="Link to the community rules and guidelines.",
+        ), dict(
+            name="schedule_text",
+            label="Schedule text",
+            default=None,
+            validator=validators.text,
+            help="Some text about when meetings are.",
+        ), dict(
+            name="schedule_link",
+            label="Schedule link",
+            default=None,
+            validator=validators.link,
+            help="Link to a schedule for IRC meetings, etc.",
+        ), dict(
+            name="minutes_link",
+            label="Minutes link",
+            default=None,
+            validator=validators.link,
+            help="Link to meeting menutes from past meetings.",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/rules.html"
+    chrome = panel()
+
+    def get_context(self, instance, *args, **kwargs):
+        owners = instance.hub.owners
+        oldest_owners = sorted(
+            owners, key=lambda o: o.created_on)[:ELLIPSIS_LIMIT]
+        oldest_owners = [{
+            'username': o.username,
+            'avatar': username2avatar(o.username)
+        } for o in oldest_owners]
+
+        owners = ordereddict([
+            (o.username, username2avatar(o.username)) for o in owners
+        ])
+        return dict(
+            oldest_owners=oldest_owners,
+            owners=owners,
+            link=instance.config["link"],
+            schedule_text=instance.config["schedule_text"],
+            schedule_link=instance.config["schedule_link"],
+            minutes_link=instance.config["minutes_link"],
+            )

